#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#include "types.h"
#include "files.h"
#include "header.h"
#include "esearch.h"
#include "egraphic.h"
#include "blocks.h"
#include "sysdep.h"
#include "key.h"
#include "menu.h"

#define max(a,b) ((a)>(b)?(a):(b))
#define min(a,b) ((a)<(b)?(a):(b))

menutyp main_menu[]=
	{	
		{"----- Main menu ----",-2},
		{"--------------------",-2},
		{"Stop and Abort",0},
		{"Load and Save",1},
		{"Search and Replace",2},
		{"Blocks",3},
		{"Makros",4},
		{"Options",5},
		{0,0}
	};

menutyp abort_menu[]=
	{	
		{"-- Stop and abort --",-2},
		{"--------------------",-2},
		{"Abort (A-C)",TABORT},
		{"Quit (A-X)",TQUIT},
		{"--------------------",-2},
		{"Close file (A-Q)",TCLOSE},
		{"Close all",TCLOSEA},
		{0,0}
	};
menutyp load_menu[]=
	{	
		{"-- Load and save ---",-2},
		{"--------------------",-2},
		{"Load ... (A-N)",TLOAD},
		{"Overload ... ",TOLOAD},
		{"--------------------",-2},
		{"Save (A-S)",TSAVE},
		{"Save w. backup (A-B)",TSAVEDUP},
		{"Save as (A-M)",TSAVEAS},
		{"Save all (F8)",TSAVEALL},
		{"Crash Save ",TSSAVE},
		{"--------------------",-2},
		{"Load block (S-F7)",TBLOAD},
		{"Save block (S-F8)",TBSAVE},
		{0,0}
	};
menutyp search_menu[]=
	{	
		{"-- Search, replace -",-2},
		{"--------------------",-2},
		{"Search ... (A-F,F1)",TSEARCH},
		{"Replace ... (A-R,F2)",TREPLACE},
		{"Again (A-G,F3)",TAGAIN},
		{"--------------------",-2},
		{"Goto Line ... (F9)",TGOTO},
		{"Set 1 (Alt-1)",TSET1},
		{"Set 2 (Alt-2)",TSET2},
		{"Set 3 (Alt-3)",TSET3},
		{"Set 4 (Alt-4)",TSET4},
		{"Goto 1 (Alt-5)",TGOTO1},
		{"Goto 2 (Alt-6)",TGOTO2},
		{"Goto 3 (Alt-7)",TGOTO3},
		{"Goto 4 (Alt-8)",TGOTO4},
		{"--------------------",-2},
		{"Link (F4)",TLINK},
		{0,0}
	};
menutyp block_menu[]=
	{	
		{"---- Block menu ----",-2},
		{"--------------------",-2},
		{"Block start (^F1)",TBBEGIN},
		{"Block end (^F2)",TBEND},
		{"Block undefine (^F6)",TBHIDE},
		{"Line block (A-L)",TBLINE},
		{"--------------------",-2},
		{"Copy block (^F3)",TBCOPY},
		{"Move block (^F4)",TBMOVE},
		{"Delete block (^F5)",TBDELETE},
		{"--------------------",-2},
		{"Format Block (^F9)",TBFORMAT},
		{"Block left (A-J)",TBLEFT},
		{"Block right (A-K)",TBRIGHT},
		{"--------------------",-2},
		{"Undo (A-U)",TUNDO},
		{0,0}
	};
menutyp options_menu[]=
	{	
		{"--- Option menu ----",-2},
		{"--------------------",-2},
		{"Format Paragraph (A-P)",TPFORMAT},
		{"Character Info (A-I)",TCINFO},
		{"Insert ASCII (A-A)",TCINSERT},
		{"Find closing bracket (F5)",TBRACKETS},
		{"Check text (A-T)",TCHECK},
		{"--------------------",-2},
		{"Delete Line (A-Y,^Back)",LDELETE},
		{"--------------------",-2},
		{"Options ... (Alt-O)",TPARAMS},
		{"--------------------",-2},
		{"Cycle windows (Alt-W,F7)",TCYCLE},
		{"Find window (F6)",TWFIND},
		{"--------------------",-2},
		{"Extend memory size",TEXTEND},
		{0,0}
	};
menutyp makro_menu[]=
	{
		{"--- Makro Menu ---",-2},
		{"------------------",-2},
		{"Makro (F10)",TMAKRO},
		{"Record (^F10)",TRECORD},
		{"Save to makros",TMSAVE},
		{0,0}
	};

menutyp *sub_menu[]=
	{	abort_menu, load_menu, search_menu, block_menu, makro_menu, 
		options_menu
	};

int next_valid (menutyp *m, int i, int n)
{	while (1)
	{	if (i>=n) i=0;
		if (m[i].selection!=-2) return i;
		i++;
	}
}

int prev_valid (menutyp *m, int i, int n)
{	while (1)
	{	if (i<0) i=n-1;
		if (m[i].selection!=-2) return i;
		i--;
	}
}

void menu_bar (menutyp *m, int i, int flag)
{	XFillRectangle(display,awindow,invgc,gl_wchar,2+i*gl_hchar,24*gl_wchar,
			gl_hchar);
	XDrawString(display,awindow,gc,gl_wchar,3+(i+1)*gl_hchar-descent,
		m[i].text,strlen(m[i].text));
	if (flag)
		XFillRectangle(display,awindow,xorgc,gl_wchar,2+i*gl_hchar,24*gl_wchar,
			gl_hchar);
}		

int select_menu (menutyp *menu, int x, int y)
{
	int i,n,ns,key,r;
	menutyp *m=menu;
	XEvent event;
	n=0; while (m->text) { m++; n++; }
	if (n==0) return 0;
	ns=next_valid(menu,0,n); 	
	XMoveResizeWindow(display,awindow,x,y,26*gl_wchar+4,n*gl_hchar+4);
	XMapWindow(display,awindow);
	neu:
	XNextEvent(display,&event);
	if (event.type==KeyPress)
	{	key=translate(&event.xkey);
		if (key==TMENU)
		{	XUnmapWindow(display,awindow); return -1;
		}
		else if (key==TRETURN)
		{	XUnmapWindow(display,awindow);
			return menu[ns].selection;
		}
		else if (key==CDOWN)
		{	menu_bar(menu,ns,0);
			ns=next_valid(menu,ns+1,n);
			menu_bar(menu,ns,1);
		}
		else if (key==CUP)
		{	menu_bar(menu,ns,0);
			ns=prev_valid(menu,ns-1,n);
			menu_bar(menu,ns,1);
		}
		goto neu;
	}
	if (event.type==Expose)
	{	process_event(&event);
		for (i=0; i<n; i++)
			XDrawString(display,awindow,gc,gl_wchar,3+(i+1)*gl_hchar-descent,
				menu[i].text,strlen(menu[i].text));
		menu_bar(menu,ns,1);
		goto neu;
	}
	if (event.type==ButtonPress)
		if (event.xbutton.window==awindow)
		{   i=(event.xbutton.y)/gl_hchar;
			if (i<0) i=0;
			if (i>=n) i=n-1;
			r=menu[i].selection;
			if (r<0) goto neu;
			XUnmapWindow(display,awindow);
			return r;
		}
		else
		{	XUnmapWindow(display,awindow);
			return -1;
		}
	goto neu;
}

int menu_length (menutyp *menu)
{	int i;
	i=0; while (menu[i].text) i++;
	return i+2;
}

void show_menu (void)
{	int selection,key,slot,y=10,hl=0,p,l;
	slot=get_top();
	if (slot>=0)
	{	y=files[slot].cursor.y;
		hl=files[slot].hl;
	}
	l=menu_length(main_menu);
	if (slot>=0 && y+2+l>=hl) p=hl-l-1;
	else p=y+2;
	if (p==0) p=1;
	selection=select_menu(main_menu,gl_wchar,p*gl_hchar);
	if (selection<0) return;
	l=menu_length(sub_menu[selection]);
	if (slot>=0 && y+2+l>=hl) p=hl-l-1;
	else p=y+2;
	if (p==0) p=1;
	key=select_menu(sub_menu[selection],30*gl_wchar,p*gl_hchar);
	if (key!=-1) menukey(key);
}

int form_alert (int def, char *sin)
{
	char string[256];
	XEvent event;
	int key,tits,ents,length,i,x,y,width,height,pos,posent[16];
	char *tit[16],*ent[16],*s;
	XWindowChanges changes;
	strcpy(string,sin); s=string;
	s++; while (*s!='[') s++;
	s++; tit[0]=s; tits=1;
	while (*s!=']')
		if (*s=='|') { tit[tits++]=s+1; *s++=0; }
		else s++;
	*s=0;
	s+=2; ents=1; ent[0]=s;
	while (*s!=']')
		if (*s=='|') { ent[ents++]=s+1; *s++=0; }
		else s++;
	*s=0;
	for (length=0, i=0, pos=1; i<ents; i++)
	{	length+=strlen(ent[i]);
		posent[i]=pos; pos+=strlen(ent[i])+2;
	}
	length+=2*ents;
	for (i=0; i<tits; i++)
		if (strlen(tit[i])+2>length) length=strlen(tit[i])+2; 
	x=4*gl_wchar;
	i=get_top();
	if (i>=0 && files[i].cursor.y<files[i].hl-tits-5) 
		y=(2+files[i].cursor.y)*gl_hchar;
	else
		if (i<0) y=10;
		else y=(files[i].cursor.y-tits-5)*gl_hchar;
	width=length*gl_wchar; height=(tits+4)*gl_hchar;
	XMoveResizeWindow(display,awindow,x,y,width,height);
	XMapWindow(display,awindow);
	for (i=0; i<ents; i++)
		XMapWindow(display,aswindow[i]);
	for (i=0; i<ents; i++)
	{	XMoveResizeWindow(display,aswindow[i],
			gl_wchar*posent[i]-gl_wchar/2,
			(tits+3)*gl_hchar-gl_hchar/3-gl_hchar+(i==def-1?0:1),
			(strlen(ent[i])+1)*gl_wchar,gl_hchar+gl_hchar*2/3);
	}
	changes.border_width=2;
	XConfigureWindow(display,aswindow[def-1],CWBorderWidth,&changes);
	startover:
	for (i=0; i<tits; i++)
		XDrawString(display,awindow,gc,
			gl_wchar,gl_hchar*(i+2)-descent,tit[i],strlen(tit[i]));
	for (i=0; i<ents; i++)
		XDrawString(display,aswindow[i],gc,
			gl_wchar/2,gl_hchar/3+gl_hchar-descent,
			ent[i],strlen(ent[i]));
	while(1)
	{	
		XNextEvent(display,&event);
		if (event.type==KeyPress)
		{	key=translate(&event.xkey);
			if (key-'0'>=1 && key-'0'<=ents) { key-='0'; break; }
			if (key==TRETURN) { key=def; break; }
			for (i=0; i<ents; i++)
				if (toupper(key)==toupper(*(ent[i])))
				{	key=i+1; goto found;
				}
		}
		else if (event.type==Expose)
		{	process_event(&event);
			goto startover;
		}
		else
		{	for (i=0; i<ents; i++)
				if (event.xbutton.window==aswindow[i])
				{	key=i+1;
					goto found;
				}
		}
	}
	found:
	for (i=0; i<ents; i++)
		XUnmapWindow(display,aswindow[i]);
	XUnmapWindow(display,awindow);
	changes.border_width=1;
	XConfigureWindow(display,aswindow[def-1],CWBorderWidth,&changes);
	refresh_top();
	return key;
}

void binput (char *prompt, char *s)
{
	XEvent event;
	int key,started=1;
	char *p;
	int slot,x,y,offset;
	slot=get_top();
	if (slot>=0)
	{	y=files[slot].cursor.y+2;
		if (y+4>=files[slot].hl) y-=6;
	}
	else y=2;
	x=gl_wchar; y=y*gl_hchar;
	p=s+strlen(s);
	*p='_'; *(p+1)=0;
	XMoveResizeWindow(display,awindow,x,y,42*gl_wchar,3*gl_hchar);
	XMapWindow(display,awindow);
	startover:
	XDrawString(display,awindow,gc,gl_wchar,3*gl_hchar/2-descent,
		prompt,strlen(prompt));
	while(1)
	{
		offset=strlen(s)-40; if (offset<0) offset=0;
		XDrawImageString(display,awindow,gc,gl_wchar,5*gl_hchar/2-descent,
			s+offset,strlen(s)-offset);
		if (strlen(s)<40)
			XFillRectangle(display,awindow,invgc,
				(strlen(s)+1)*gl_wchar,3*gl_hchar/2+1,
				(40-strlen(s))*gl_wchar,gl_hchar);
		XNextEvent(display,&event);
		if (event.type==Expose)
		{	process_event(&event);
			goto startover;
		}
		key=translate(&event.xkey);
		if (key==TRETURN) break;
		else if (key==TBACKSPACE && p>s) { p--; started=0; }
		else if (key==TMENU)
			if (p==s) break;
			else { p=s; started=0; }
		else if (key>0 && key<256 && strlen(s)<254) 
		{	if (started) p=s;
			*p++=key;
			started=0;
		}
		*p='_'; *(p+1)=0;
	}
	*p=0;
	XUnmapWindow(display,awindow);
}

